package Caching;

import java.io.File;
import java.io.*;
import java.net.*;
import java.lang.*;
import HTTPClient.*;
import HTTPMethods.*;

/**
 * <Design Spec> Given a web page, cache it.
 * web page related functions
 * hate to use URI, file mapping, but whatever you ask.
 **/
import StartAllServers.Debug;
import StartAllServers.*;

public class HandleWebPage 
{
  //this flag is important to solve the sync problem of glimpseindex.
  //if several glimpses is running, the results will be very bad
  public HandleWebPage()
  { }


    /** Written by DA
     *  basically given a url this will return 
     *  This function also transforms the filename into MD5 format
     *  before checking if it is in the cache
     */
    public boolean FileisInCache(String request, boolean restricted) {

	FileWrap fis = FileWrap.getInstance();

	String repTime = "Start Local Cache Search " + System.currentTimeMillis() + "\n";
	byte[] repT = new byte[repTime.length()];
	repTime.getBytes(0, repTime.length(), repT, 0);
	
	fis.write(repT);				    		

	request = request.trim();
	
	if (restricted) {
	    CacheBuffer cb = CacheBuffer.getInstance();
	    BufferEntry entry = cb.getBufferEntry(request);
	    if (entry == null){
		System.out.println("_____________________ENTRY NOT FOUND  " + request);
		return false;
	    }
	    
	    
	    else if (entry.getFolder().trim().equals("private")){
		System.out.println("_____________________FAILED DUE TO PRIVATE");
		System.out.println(entry);
		return false;
	    }
	    
	

	    //this is a http page serve
	    String fileName = request.substring(7);
	    fileName=ParseRequest.attachIndexHtml(fileName);
	    
	    int index = fileName.lastIndexOf('/');
	    String uName = fileName.substring(index+1, fileName.length());
	    
	    /************ADDED CODE*****************/	    
	    //transform filename to MD5 format before checking existence
	    MD5 md5 = new MD5();
	    
	    String dirName = (new String(Constants.CACHE_DIR + "/")).concat(md5.toDigest(fileName.substring(0, index)));
	    fileName = dirName + "/" +uName;
	    
	    File file = new File(fileName);
	    System.out.println("The file to be sent is: " + file);
	    return file.exists();
	}
	
	//this is a http page serve
	System.out.println("REQUEST FILE CACHE " + request);
	request = requestChecker(request);
	//	String fileName = request.substring(0, index-4);
	String fileName = request.substring(7);
	fileName=ParseRequest.attachIndexHtml(fileName);
	
	int index = fileName.lastIndexOf('/');
	String uName = fileName.substring(index+1, fileName.length());
	
	
	//Convert filename to MD5 format before checking existence
	MD5 md5 = new MD5();
	//	String dirName = fName.substring(0, index);
	String dirName = (new String(Constants.CACHE_DIR + "/")).concat(md5.toDigest(fileName.substring(0, index)));
	fileName = dirName + "/" +uName;

	File file = new File(fileName);
	System.out.println("The file to be sent is: " + file);
	/**************************************/

	String endTime = "Finish Local Cache Search " + System.currentTimeMillis() + "\n";
	byte[] endT = new byte[endTime.length()];
	endTime.getBytes(0, endTime.length(), endT, 0);
	
	fis.write(endT);				    		

	return file.exists();
    }

    public String requestChecker(String request){
	for(int i = 8; i<request.length(); i++){
	    if(request.substring(i-8,i).equals("HTTP/1.0")){
		String temp = request.substring(4,i-9);
		System.out.println("TEMP: " + temp);
		return temp;
	    }
	}
	return request;
    }

    /* get the data from the cache
     * Written by DA
     * Converts filename to MD5 before retrieving
     */
    public boolean getFromCache(String url, DataOutputStream os) {
	int end;

	if (Debug.DEBUG_Caching == true) { 
	    System.out.println("%%%%%%%%%%%%%%%%% Getting from cache %%%%%%%%%%%%%%"); 
 	
 	}
	if (url.trim().endsWith("/")) {
	    url = url.trim().concat("index.html");
	}
	int index = url.indexOf("//");

	int index2 = url.lastIndexOf('/');
	String uName = url.substring(index2+1, url.length());

	/**************ADDED CODE********************/
	//Convert filename to MD5 format before retrieval
	MD5 md5 = new MD5();

	System.out.println("URL SUB: " + url.substring(index+2, index2));
	String dirName = (new String(Constants.CACHE_DIR + "/")).concat(md5.toDigest(url.substring(index+2, index2)));
	String fName = dirName + "/" +uName;
	/****************************************/


	if (Debug.DEBUG_Caching == true) { 
	    System.out.println("%%%%%%%%%%%% FILENAME IS: " + fName + " %%%%%%%%%%%%%%%%%"); 
 	} 
 	
	try {
	    File file = new File(fName);
	    FileInputStream fin = new FileInputStream(file);
	    byte b[] = new byte[1024];
	    int l;

	    while ((l = fin.read(b)) > 0) {
		os.write(b, 0, l);
	    }

	    return true;
	    
	} catch (FileNotFoundException e) {
	    System.err.println("File not found: " + fName);
	    return false;
	} catch (SecurityException e) {
	    System.err.println("Security problem with: " + fName);
	    return false;
	} catch (IOException e) {
	    System.err.println("IOException: " + e.getMessage());
	    return false;
	}
    }

    //cache the web page if doICache returns true
    public void cache(String request, HTTPResponse rsp, byte[] data) {

	String URL = ParseRequest.getURL(request);
	try {
	    //cache if need be
	    if (doICache(request)) {
		FileOutputStream fout = saveToCache(URL);
		fout.write(data, 0, data.length);
		
		//add to the buffer
		CacheBuffer mybuffer = CacheBuffer.getInstance();
		mybuffer.addURLToBuffer(ParseRequest.attachIndexHtml(URL), rsp);
		System.out.println("ADDING URL TO CACHE: " + URL);
	    }
	} catch (Exception e) {
	   e.printStackTrace();
	}
    }   
	
    //this method is only called when a web page comes by way
    //of pre-fetching as used in the WebClient. We DEFINITELY
    //need to cache it if we decided to pre-fetch it.
    public void cache(URL myurl, HTTPResponse rsp, byte[] data) {
	
	String URL = myurl.toString();
	try {
	    
	    FileOutputStream fout = saveToCache(URL);
	    fout.write(data, 0, data.length);
	    
	    //add to the buffer
	    CacheBuffer mybuffer = CacheBuffer.getInstance();
	    mybuffer.addURLToBuffer(ParseRequest.attachIndexHtml(URL), rsp);
	    System.out.println("ADDING URL TO CACHE: " + URL);

	} catch (Exception e) {
	    System.err.println("In handleWebPage: " + e.getMessage());
	}
    }

    
	

    //Do I cache the current page?
    public boolean doICache(String request) {
	String URL = ParseRequest.getURL(request);

	//block everything to/from the local host
	if (!ParseRequest.addressedToMyHost(request))
	    return true;
	
	//otherwise don't cache
	return false;
	
    }
  
  

    /* Written by DA
     * I need it to return a file output stream
     * Converts filename to MD5 format before saving
     */
    public FileOutputStream saveToCache(String url) {
	int index = url.indexOf("//");
	String fName = (new String(Constants.CACHE_DIR + "/")).concat(url.substring(index+2));

	//make sure to deal with the case of no specified file correctly
	
	fName = ParseRequest.attachIndexHtml(fName);
	//	System.out.println("fName " + fName);

	/*
	if (fName.trim().endsWith("/")) 
	    
	    fName = fName.concat("index.html");
	*/
	if (Debug.DEBUG_Caching == true) { 
	    System.out.println("CACHE: Creating: " + fName); 
 	
 	}
	try{	//	String fName = (new String(Constants.CACHE_DIR + "/")).concat(url.substring(index+2));

	    int first = index;
	    index = fName.lastIndexOf('/');
	    String uName = fName.substring(index+1, fName.length());


	    /**************ADDED CODE********************/
	    //Convert to MD5 filename format before saving
	    MD5 md5 = new MD5();

	    index = url.lastIndexOf('/');

	    String dirName = (new String(Constants.CACHE_DIR + "/")).concat(md5.toDigest(url.substring(first+2, index)));
	    fName = dirName + "/" +uName;
	    /**********************************/

	    File dir = new File(dirName);
	    dir.mkdirs();
	    File file = new File(fName);
	    file.createNewFile();
	    FileOutputStream fout = new FileOutputStream(file);
	    return fout;
	} catch (Exception e) {
	   
	    if (Debug.DEBUG_Caching == true) { 
		System.out.println(e.getMessage()); 
	    } 
 	
	}
	return null;
    }
}


