package Caching;
import java.io.*;
import java.net.*;
import java.util.*;

/* This class is a wrapper class for a hash table
 * It is used to maintain one instance of a hash table
 * over multiple components.
 */
public class HashWrapper{

    private static HashWrapper hWrap;
    Hashtable hTable;

    /* Private Constructor */
    private HashWrapper() {

	hTable = new Hashtable();

    }

    /* Maintains the single instance of the hash table */
    public static synchronized HashWrapper getInstance() {
	if(hWrap == null){
	    hWrap = new HashWrapper();
	}
	return hWrap;
    }

    /* Retrieve value from hash table */
    public Object get(Object key){
	return (hTable.get(key));
    }

    /* Insert value into hash table */
    public Object put(Object key, Object value){
	return (hTable.put(key, value));
    }

    /* Remove value from hash table */
    public Object remove(Object key){
	return(hTable.remove(key));
    }
}




