package Caching;

import HTTPMethods.*;
import StartAllServers.*;
import java.io.*;
import java.lang.*;
import java.net.*;

/**
 **/
public class SearchEngine
{
  private static final int TITLE_READIN_SIZE = 350;

  public SearchEngine()
  {}

    public String glimpseSearch(String keyPhrase)
    { 

	//String keyPhrase;
	//keyPhrase = query.substring(index2+1, index);

    //use -N search only index. -l, search file as well.
    //use -N only because that is what index is there for.
    String cmd = Constants.GLIMPSE_EXE + " -H " + Constants.GLIMPSE_GEN_FILES + " -c -i -N -y " + "\"" + keyPhrase + "\"";
   
    if (Debug.DEBUG_Caching == true) { 
	System.out.println("In GlimpseSearch executing: " + cmd); 
    } 
 
    StringBuffer sbuf = new StringBuffer(Constants.MAX_BUF_LEN);
    String line;
    
    try {
	Process child = Runtime.getRuntime().exec(cmd);
	InputStream output = child.getInputStream();
	InputStreamReader reader = new InputStreamReader(output);
	BufferedReader in = new BufferedReader(reader);
	
	FileInputStream fin;
	long lastModified;
	
	while ((line = in.readLine()) != null)
	    sbuf.append(line);
    } catch (Exception e) {
        e.printStackTrace();
    }
    
    return (new String(sbuf));
    }

    
    //<Denis>just returns an XML formatted String which gives the title of 
    //the web page, expiration, age, URL, etc.
    //basically everything I need to send via UDP.
    //gets the report by running the keywords through the search engine
    public String getReport(String keyPhrase)
	{
	    int index;
	    int index2;
	    System.out.println("The keyphrase is: " + keyPhrase);
	    //use -N search only index. -l, search file as well.
	    //use -N only because that is what index is there for.
	    String cmd = Constants.GLIMPSE_EXE + " -H " + Constants.GLIMPSE_GEN_FILES + " -c -i -N -y " + "\"" + keyPhrase + "\"";
	    if (Debug.DEBUG_Caching == true) {  
		System.out.println("In get report executing: " + cmd); 
		
	    }
	    
	    StringBuffer sbuf = new StringBuffer(Constants.MAX_BUF_LEN);
	    int count=0;
	    
	    try {
		Process child = Runtime.getRuntime().exec(cmd);
		InputStream output = child.getInputStream();
		InputStreamReader reader = new InputStreamReader(output);
		BufferedReader in = new BufferedReader(reader);
		
		FileInputStream fin;
		long lastModified;
		byte buffer[] = new byte[Constants.TMP_BUF_LEN];
		String tmpLine, line, uri, title, fname;
		//String localHost = new String("http://" + InetAddress.getLocalHost().getHostAddress());
		String localHost = new String("http://" + StartAllServers.AD_HOC_IP_ADDRESS);
		
		while ((line = in.readLine()) != null)
		{
		    //System.out.println(line);
		    count ++;
		    
		    if (line.indexOf('/') <0)
		    { //SOMETIME, glimpse gives out a line, sometimes not. 
			continue;
		    }
		    HandleWebPage hp = new HandleWebPage();
		    String tempurl = ParseRequest.convertCachePathToURL(line);
		    
		    if(hp.FileisInCache(tempurl, true))
		    {
			
			
			fin = new FileInputStream(line);
			
			//now, get the title first. Usually <title> has to be at the very
			//beginging of the html page. We read the first 100 chars. If <title>
			//is found, we read it. Otherwise, we claim we do not find <title>
			
			fin.read(buffer, 0, TITLE_READIN_SIZE);
			if ( (title = getTitle(buffer)) == null)
			{
			    title = line;
			}
			
			
			lastModified = (new File(line)).lastModified();
			
			index = line.indexOf(".cache");
			index2 = line.indexOf('/', index);
			fname = line.substring(index2);
			
			sbuf.append("<Report><Title>" + title + "</Title><Orig-URL>http:/" + 
				    fname + "</Orig-URL><Local>" + localHost + ":" + StartAllServers.WebServerPort + fname + 
				    "</Local><Age>" + lastModified + "</Age></Report>");
			
		    }
		    
		}
		
	    } catch (IOException e) {
		e.printStackTrace();
	    }
	    if (count == 0)
		return null;
	    else if (sbuf.toString().equals(""))
		return null;
	    else
		return (new String("<?xml version=\"1.0\"?><response><QueryDescriptor>" 
				   + keyPhrase + "</QueryDescriptor>" + (new String(sbuf)) + "</response>"));
	    
	    
	}
    
    
    
    
    /* try a particular URL. If it exists in our cache then just return
     * the descriptor for that url
     * Convert url to MD5 format before adding to the report
     */
    public String getURLFromCache(String URL) {
	URL = ParseRequest.attachIndexHtml(URL);
	
	String fileName = URL.substring(7);
	String line = Constants.CACHE_DIR + "/" + fileName;

	HandleWebPage hp = new HandleWebPage();

	String tempurl = ParseRequest.convertCachePathToURL(line);
	
	if(hp.FileisInCache(tempurl, true)) {
	    StringBuffer sbuf = new StringBuffer();
	    String localHost = new String("http://" + StartAllServers.AD_HOC_IP_ADDRESS);
		
	    int index = line.indexOf(".cache");
	    int index2 = line.indexOf('/', index);
	    String fname = line.substring(index2);

	    String fname2 = line.substring(index2+1);
	    System.out.println("FNAME: " + fname2);
	    int index3 = fname2.lastIndexOf('/');
	    String uName = fname2.substring(index3+1, fname2.length());	      

	    /**************ADDED CODE***********************/
	    //Convert filename to MD5 format before putting in report
	    MD5 md5 = new MD5();
	    String dirName = md5.toDigest(fname2.substring(0, index3));
	    String line2 = Constants.CACHE_DIR + "/" + dirName + "/" + uName;
	    long lastModified = (new File(line2)).lastModified();	    
	    /******************************************/
	    sbuf.append("<Report><Title>" + URL + "</Title><Orig-URL>http:/" + 
			fname + "</Orig-URL><Local>" + localHost + ":" + StartAllServers.WebServerPort + fname + 
			"</Local><Age>" + lastModified + "</Age></Report>");
	    
	    return (new String("<?xml version=\"1.0\"?><response><QueryDescriptor>" 
			       + URL + "</QueryDescriptor>" + (new String(sbuf)) + "</response>"));
	}
	
	else
	    return null;
    }
	    
    public String getDescriptor(String URL) {
	URL = ParseRequest.attachIndexHtml(URL);
	
	String fileName = URL.substring(7);
	String line = Constants.CACHE_DIR + "/" + fileName;

	HandleWebPage hp = new HandleWebPage();

	String tempurl = ParseRequest.convertCachePathToURL(line);
	
	if(hp.FileisInCache(tempurl, true)){
	    		    
	    StringBuffer sbuf = new StringBuffer(Constants.MAX_BUF_LEN);
	    int index, index2, count;
	    FileInputStream fin;
	    long lastModified;
	    //String line = filename;
	    byte buffer[] = new byte[Constants.TMP_BUF_LEN];
	    String tmpLine, uri, title, fname;
	    
	    try {
		
		//String localHost = new String("http://" + InetAddress.getLocalHost().getHostAddress());
		String localHost = new String("http://" + StartAllServers.AD_HOC_IP_ADDRESS);
		fin = new FileInputStream(line);
		
		//now, get the title first. Usually <title> has to be at the very
		//beginging of the html page. We read the first 100 chars. If <title>
		//is found, we read it. Otherwise, we claim we do not find <title>
		
		fin.read(buffer, 0, TITLE_READIN_SIZE);
		if ( (title = getTitle(buffer)) == null)
		{
		    title = line;
		}
		//System.out.println("title=" + title);
		
		lastModified = (new File(line)).lastModified();
		
		index = line.indexOf(".cache");
		index2 = line.indexOf('/', index);
		fname = line.substring(index2);
		
		sbuf.append("<Report><Title>" + title + "</Title><Orig-URL>http:/" + 
			    fname + "</Orig-URL><Local>" + localHost + ":" + StartAllServers.WebServerPort + fname + 
			    "</Local><Age>" + lastModified + "</Age></Report>");
		//System.out.println(new String(sbuf));
		
	    } catch (IOException e) {
		e.printStackTrace();
	    }
	
	
	    return (new String("<?xml version=\"1.0\"?><response><QueryDescriptor>" 
			       + URL + "</QueryDescriptor>" + (new String(sbuf)) + "</response>"));
	}
	return null;
	
    }
        
    
  //if the buffer size is large. This is inefficient to change to all lower.
  private String getTitle(byte[] buffer)
  {
     int pos1, pos2;
     String title;
     String str = (new String(buffer)).toLowerCase();

        if ( (pos1 = str.indexOf("<title>")) > 0)
        {
          pos2 = str.indexOf("</", pos1);
          if (pos2 < 0)
            pos2 = str.lastIndexOf(' ');
          if (pos2 < pos1)
            title = null;
          else
          {
            pos1 = str.lastIndexOf('>', pos2);
            title = str.substring(pos1+1, pos2);
          }
        } else {
            title = null;
        }

    return title;
  }

}













