package UDPMulticast;
import java.io.*;
import java.net.*;
import java.util.*;

/* This class is a wrapper class for a Vector.  It is used
 * to maintain a single instance of the Vector.
 */
public class VectorWrapper{

    private static VectorWrapper vWrap;
    Vector vec;

    /**
     * Private Constructor
     */
    private VectorWrapper() {

	vec = new Vector();

    }

    /**
     * Method that returns a copy of VectorWrapper.  It ensures
     * that there is only one copy in use.
     */
    public static synchronized VectorWrapper getInstance() {
	if(vWrap == null){
	    vWrap = new VectorWrapper();
	}
	return vWrap;
    }

    /**
     * Method that returns the element at index using
     * normal vector operations.
     */
    public Object elementAt(int index){
	return (vec.elementAt(index));
    }

    /**
     * Method that adds the element value using
     * normal vector operations.
     */
    public void addElement(String value){
	vec.addElement(value);
    }

    /**
     * Method that removes the element with value key using
     * normal vector operations.
     */
    public boolean removeElement(Object key){
	return (vec.removeElement(key));
    }

    /**
     * Method that returns the size of the vector using
     * normal vector operations.
     */
    public int size(){
	return (vec.size());
    }

    /**
     * Method that returns the index of the element with value  using
     * normal vector operations.
     */
    public int indexOf(String value){
	return (vec.indexOf(value));
    }
}




