package WebClient;
import java.io.*;
import java.net.*;
import java.util.*;

/* This class is a wrapper for a hash table.  It is used to 
 * maintain a single hash table over multiple components
 */
public class HashWrapper2{

    private static HashWrapper2 hWrap;
    Hashtable hTable;

    private HashWrapper2() {

	hTable = new Hashtable();

    }

    /**
     * Method to return the single copy of HashWrapper2 used by the system
     */
    public static synchronized HashWrapper2 getInstance() {
	if(hWrap == null){
	    hWrap = new HashWrapper2();
	}
	return hWrap;
    }

    /**
     * Method that returns the object associated with the key value
     * using hash table operations.
     */
    public Object get(Object key){
	return (hTable.get(key));
    }

    /**
     * Method that inserts the object key-value pair
     * using hash table operations.
     */
    public Object put(Object key, Object value){
	return (hTable.put(key, value));
    }

    /**
     * Method that removes the object associated with the key value
     * using hash table operations.
     */
    public Object remove(Object key){
	return(hTable.remove(key));
    }
}




