package WebClient;

import HTTPClient.*;
import java.lang.*;
import java.io.*;
import java.net.*;
import Caching.*;
import java.util.*;
import StartAllServers.Debug;
import StartAllServers.*;

public class WebRetrieve {

    URL myurl;
    String host;
    int port;
    String path;
    String file;
    String real_host;
    HashWrapper2 hWrap2;

    /**
     * Constructor that takes url to be retrieved.
     * Creates an instance of a hash table.  The hash table
     * creates a pairing between a domain name and a peer ip address
     */
    public WebRetrieve(String url) {
	hWrap2 = HashWrapper2.getInstance();	
	parseURL(url); 
    }

    /**
     * Method to parse the URL
     */
    public void parseURL(String URLstring) {
	try {
if (Debug.DEBUG_WebClient == true) { 
 	 System.out.println("In constructor the URL string is: " + URLstring); 
 	}
	    this.myurl = new URL(URLstring);
	    this.host = myurl.getHost();
	    this.port = myurl.getPort();
	    if (port == -1) {
		port = 80;
	    }
		    
	    this.path = myurl.getPath();
	    this.file = myurl.getFile();
	} catch (MalformedURLException e) {
	    System.out.println("Getting Malformed URL Exception");
	    System.err.println(e.getMessage());
	}

    }

    /**
     * Deprecated and not in use
     */
    public void parseText(String myhtml) {
	if (Debug.DEBUG_WebClient == true) { 
	    System.out.println("In parse text"); 
 	}
	StringTokenizer mytoken = new StringTokenizer(myhtml, "<>");
	char [] gifval = new char[5];
	char [] jpgval = new char[5];
	gifval[0] = '.';
	gifval[1] = 'G';
	gifval[2] = 'I';
	gifval[3] = 'F';
	gifval[4] = '"';
	jpgval[0] = '.';
	jpgval[1] = 'J';
	jpgval[2] = 'P';
	jpgval[3] = 'G';
	jpgval[4] = '"';
	while (mytoken.hasMoreElements()) {
	    String test = mytoken.nextToken();
	    if (test.toUpperCase().indexOf(new String(gifval)) > -1 ||
		test.toUpperCase().indexOf(new String(jpgval)) > -1 ||
		test.toUpperCase().indexOf("IMG SRC") > -1) {
		
		//usually the syntax is <IMG SRC = "http://something"
		StringTokenizer temp = new StringTokenizer(test, "\t\n\r= ", false);
		temp = new StringTokenizer(test, "\t\n\r= ", false);
		if (temp.countTokens() > 3) {
		    while(temp.hasMoreElements()){
			String url = temp.nextToken();
			if(url.toUpperCase().indexOf("IMG") > -1){
			    url = temp.nextToken();
			    if(url.toUpperCase().indexOf("SRC") > -1){
				url = temp.nextToken();
				url = clean_url(url);
				WebRetrieve myWebClient = new WebRetrieve(url);
				myWebClient.sendRequest();
			    }
			}else if(url.toUpperCase().indexOf(".GIF") > -1 ||
				 url.toUpperCase().indexOf(".JPG") > -1){
			    if (Debug.DEBUG_WebClient == true) { 
				System.out.println("Url is " + url); 
			    }
			    url = clean_url(url);
			    WebRetrieve myWebClient = new WebRetrieve(url);
			    myWebClient.sendRequest();
			}
		    }
		    
		}
	    }
	}
    }
    
    /**
     * Method to form an absolute URL from a relative one
     */
    public String clean_url(String url) {
	url = url.trim();
	StringBuffer urls = new StringBuffer(url);
	if (urls.charAt(0) == '"')
	    urls.deleteCharAt(0);
	if (urls.charAt(urls.length()-1) == '"') 
	    urls.deleteCharAt(urls.length()-1);
	
	if (urls.toString().startsWith("http://")) { 
	    urls.insert(6, "/" +  host + ":" + port);
	    if (Debug.DEBUG_WebClient == true) { 
		System.out.println("Final result is " + urls.toString()); 
	    }
	    return urls.toString();
	}
	
	if (urls.charAt(0) != '/') {
	    urls.insert(0, path.substring(0, path.lastIndexOf("/")+1));
	    urls.insert(0, "http://" + host + ":" + port );
	    if (Debug.DEBUG_WebClient == true) { 
		System.out.println("Final result is " + urls.toString()); 
	    }
	    return urls.toString();
	}
	
	urls.insert(0, "http://" + host + ":" + port + "/" + real_host );
	if (Debug.DEBUG_WebClient == true) { 
	    System.out.println("Final result is: " + urls.toString()); 
 	}
	return urls.toString();
    }
    
    
    //just take out the IP of the host where this page came from
    public String avoidPropagation() {
	if (Debug.DEBUG_WebClient == true) { 
	    System.out.println("The path is: " + path); 
 	}
	
	//global variable describing this connection
	int start = path.indexOf("/");
	int end = path.indexOf("/", start+1);
	this.real_host = path.substring(start+1,end);
	
	if (Debug.DEBUG_WebClient == true) { 
	    System.out.println("The real host is:" + this.real_host); 
 	}
	String new_url =  "http:/" + path;
	if (new_url.trim().endsWith("/")) 
	    new_url =  new_url.trim().concat("index.html");
	System.err.println("Propagation URL is: " + new_url);
	return new_url;
    }
    
    
    /**
     * Method to send GET requests to peer.  Only retrieves the
     * first page.  Then it creates and stores an association
     * between the hostname and the peer address.
     */
    public boolean sendRequest() {
	byte[] data;
	HTTPConnection con = new HTTPConnection(host, port);

	FileWrap fis = FileWrap.getInstance();
	
	try {
	    checkURL();
	    System.out.println("***THE GET REQUEST IS: GET " + path);

	    String endTime = "Start Get Request " + path + " " + System.currentTimeMillis() + "\n";
	    byte[] endT = new byte[endTime.length()];
	    endTime.getBytes(0, endTime.length(), endT, 0);
	    
	    fis.write(endT);

	    HTTPResponse rsp = con.Get(path);

	    String gTime = "End Get Request " + path + " " + System.currentTimeMillis() + "\n";
	    byte[] gT = new byte[gTime.length()];
	    gTime.getBytes(0, gTime.length(), gT, 0);
	    
	    fis.write(gT);
	    
	    if (rsp.getStatusCode() >= 400) {
		if (Debug.DEBUG_WebClient == true) { 
		    System.out.println("File doesn't exist on: " + host + " filename: " + path); 
		}
		//don't need to save anything in this case
	    }
	    
	    else {
		System.out.println("WEB RETRIEVE");
		System.out.println("HOST: " + host);
		System.out.println("REAL HOST: " + real_host);
		data = rsp.getData();
		String url_temp = avoidPropagation();
		HandleWebPage hp = new HandleWebPage();

		hp.cache(new URL(url_temp), rsp, data);
		if (Debug.DEBUG_WebClient == true) { 
		    System.out.println("After cache"); 
		}
		String type = rsp.getHeader("Content-Type");
		if (Debug.DEBUG_WebClient == true) { 
		    System.out.println("The type is: " + type); 
		}
		/*		if (type.startsWith("text")) {
		    parseText(new String(data));
		    }*/
		System.out.println("HOST: " + host);
		System.out.println("REAL HOST: " + real_host);

		/*****************ADDED CODE******************/
		//Creates and inserts hostname-peer address pair
		//into hash table
		hWrap2.put(new Integer(real_host.trim().hashCode()), host);    
		/************************************************/
	    }
	} catch (Exception e) {
	    System.err.println(e.getMessage());
	    e.printStackTrace();
	    return false;
	}
	return true;
    }
    
    /**
     * Method to validate the URL and remove empty space.
     */
    public void checkURL(){
	int place = 0;
	for(int i=0; i<path.length(); i++)
	    if(path.charAt(i) == '\n'){
		place = i;
		i = path.length();
	    }
	if(place != 0)
	    path = path.substring(0, place);
	System.out.println("NEW PATH: " + path);
    }
    
    /**
     * Deprecated and not in use
     */
    public static void main(String[] args) {
	
	String URL = "http://128.59.15.37:9000/www.cs.brandeis.edu/index.html";
	WebRetrieve myWebClient = new WebRetrieve(URL);
        myWebClient.sendRequest();
    }
}










